import express from 'express';
import { handler as ssrHandler } from './dist/server/entry.mjs';
import dataRouter from './server/dataRouter.js';
import cors from 'cors';

const app = express();
app.use(express.static('dist/client/'))
app.use(ssrHandler);
app.use('/node', dataRouter);

app.use(cors()); 

// login integration
// JWT dient der Verwaltung der JSON Webtokens. Jede Anfrage wird 
// durch JWT geleitet. Alle geschützten Routen wird das entschlüsselte 
// JWT Objekt an das Request (req)-Objekt angehängt. 
//import jwt from "./server/login/jwt.js";
//app.use(jwt());

const myMiddleware = (req, res, next) => {
    console.log("MyMiddleware");
    next(); 
}

app.get('/myapi/hello', myMiddleware, (req, res) => {
    console.log(req.params);
    res.send('Hello World!')
})



app.listen(3000, () => {
    console.log("server running on port 3000")
});