import { defineConfig } from "astro/config";
import tailwind from "@astrojs/tailwind";
import image from "@astrojs/image";
import mdx from "@astrojs/mdx";
import sitemap from "@astrojs/sitemap";
import solid from "@astrojs/solid-js"
import node from '@astrojs/node';

export default defineConfig({
  site: "https://astroship.web3templates.com",
  adapter: node({
    mode: 'middleware'
  }),
  output: "server",
  integrations: [
    tailwind(),
    image({
      serviceEntryPoint: "@astrojs/image/sharp",
    }),
    mdx(),
    /*sitemap(),*/
    solid()
  ],
});
