var express = require('express');
var router = express.Router();
const jwt = require("jsonwebtoken");

const path = require('path');
var sqlite3 = require('sqlite3');

// Name der Datenbankdatei, die im Ordner "routes" abgelegt ist.
const dbPath = path.resolve(__dirname, 'inventory.db');
const { uuid } = require('uuidv4');

// Das Datenmodell (Datenmodell - Ausleihsystem) beinhaltet die Tabelle User und die Tabelle UserInfo

function initDatabase() {
  // Tabelle User erzeugen
  let query = "CREATE TABLE IF NOT EXISTS User ( id TEXT NOT NULL, " +
      "username TEXT NOT NULL DEFAULT '', password TEXT NOT NULL DEFAULT '')"
  db.run (query);

  query ="CREATE TABLE IF NOT EXISTS UserInfo ( id TEXT NOT NULL, " +
      "firstname TEXT NOT NULL DEFAULT '', lastname TEXT NOT NULL DEFAULT '', " +
      "imageLink TEXT NOT NULL DEFAULT '' , description TEXT NOT NULL DEFAULT '', " +
      "adminRole INTEGER NOT NULL DEFAULT 0, rentRole INTEGER  NOT NULL DEFAULT 1, " +
      "userId TEXT NOT NULL)";
  db.run (query);
}

// Verbindung zur Datenbank herstellen
let db = new sqlite3.Database(dbPath, (err) => {
  if (err) {
    console.error(err.message);
  }
  initDatabase();
  console.log('Connected to inventory database.');
});

// Alle Nutzer abrufen. localhost:3005/api/user/all
router.post('/authenticate', function(req, res, next) {
  if ( req.body.hasOwnProperty("username")
      && req.body.hasOwnProperty("password")) {
      let username = req.body.username;
      let password = req.body.password;

      db.all("SELECT User.id, User.username, User.password, UserInfo.firstname, UserInfo.lastname, UserInfo.imageLink, UserInfo.description, UserInfo.adminRole, UserInfo.rentRole FROM User LEFT JOIN UserInfo ON User.id = UserInfo.userId where username = (?)", [username], (err, users) => {
        if (err) {
          return res.send({ success: "error", message: err.message });
        }

        if (users.length === 0) {
            return res.send({ success: "error", message: "invalid username" });
        }

        if (users[0].password === password) {
            let userObject = {
              id: users[0].id,
              username: users[0].username,
              firstname: users[0].firstname,
              lastname: users[0].lastname,
              description: users[0].description,
              imageLink: users[0].imageLink,
              adminRole: users[0].adminRole,
              rentRole: users[0].rentRole
            }
            const secret = "oRs2ciVCayoy5f64";
            const token = jwt.sign(userObject, secret);

            let user = {
              user: userObject,
              token: token
            }
            res.send({success: "ok", user: user});
        } else {
          res.send({success: "error", message: "invalid credentials"});
        }
      });
    } else {
        res.send({ success: "error", message: "attributes missing"});
    }
});


module.exports = router;
