import sqlite from 'better-sqlite3';
import path from 'path';
import { v4 as uuidv4 } from 'uuid';
import { writeFile } from 'fs/promises';

const dbPath = path.resolve("./src/db/", 'rental.db');
const imgPath = path.resolve("./public/img/car/");

export async function post({ request }) {
    console.log("POST")
    const formData = await request.formData();
    console.log(formData);
    let imgFileName = "";
    let imgName = ""; 
    await Promise.all(
        formData
          .getAll('image')
          .map(async (file: File) => {
            imgFileName = file.name; 
            // mycar.jpg - 12.11.2010-MeinAutoüäö.jpg --> .jpg ausschneiden
            let suffix = file.name.substring(file.name.lastIndexOf('.'), file.name.length);
            imgName = uuidv4() + suffix;
            writeFile(
                path.resolve(imgPath, imgName),
                new Uint8Array(await file.arrayBuffer())
            ) 
          })         
      );
      await Promise.all(
        formData.getAll("carId").map(carId => {
            let db = new sqlite(dbPath);
            const updates = db.prepare('UPDATE Cars SET img = ?, imgName = ? WHERE id = ?')
                     .run(imgName, imgFileName, carId); 
            db.close();
        })
      ); 
    return {
        body: JSON.stringify({
            success: "ok",
            errorMessage: "Image saved"
        })
      };
  }